// DevicePCI.h
//
// Generated by C DriverWizard 3.1.0 (Build 1722)
// Requires DDK Only
// File created on 5/30/2008
//
#ifndef __DEVICEPCI_H__
#define __DEVICEPCI_H__

#ifndef RTL_CONSTANT_STRING
#define RTL_CONSTANT_STRING(s) { sizeof( s ) - sizeof( (s)[0] ), sizeof( s ), s }
#endif

// Memory allocation pool tag
#define DEVICEPCI_POOL_TAG 'iveD'

// Make all pool allocations tagged
#undef ExAllocatePool
#define ExAllocatePool(type, size) \
    ExAllocatePoolWithTag(type, size, DEVICEPCI_POOL_TAG);

// queue start io callback
typedef VOID (*PDEVICEPCI_QUEUE_STARTIO)(
    IN PDEVICE_OBJECT   DeviceObject,
    IN PIRP             Irp 
    );

// irp queue type definition
typedef struct _DEVICEPCI_QUEUE
{
    PDEVICEPCI_QUEUE_STARTIO StartIoRoutine;
    PDEVICE_OBJECT  DeviceObject;
    LIST_ENTRY      IrpQueue;
    KSPIN_LOCK      QueueLock;
    PIRP            CurrentIrp;
    KEVENT          StopEvent;
    LONG            StallCount; 
    NTSTATUS        ErrorStatus;
    KDPC            DevicePCIStartIoDpc;
    BOOLEAN         bUseDevicePCIStartIoDpc;
} DEVICEPCI_QUEUE, *PDEVICEPCI_QUEUE;

// cancel-safe irp list type definition
typedef struct _DEVICEPCI_LIST
{
    PDEVICE_OBJECT  DeviceObject;
    LIST_ENTRY      IrpList;
    KSPIN_LOCK      ListLock;
    NTSTATUS        ErrorStatus;
} DEVICEPCI_LIST, *PDEVICEPCI_LIST;

// stall IRP list to syncronize Pnp, Power with
// the rest of IO
typedef struct _DEVICEPCI_IO_LOCK
{
    PDEVICE_OBJECT  DeviceObject;       // our device object
    KEVENT          StallCompleteEvent; // io stalled event
    LIST_ENTRY      StallIrpList;       // stalled irps
    KSPIN_LOCK      IoLock;             // spin lock to syncronize io with stall/unstall
    LONG            StallCount;         // number of times stall was requested
    LONG            ActiveIrpCount;     // number of oustanding, not-stalled IRPs
    NTSTATUS        ErrorStatus;
    PIRP            CurrentIrp;         // used by unstall code
} DEVICEPCI_IO_LOCK, *PDEVICEPCI_IO_LOCK;

// global (per driver) data block
typedef struct _DEVICEPCI_DATA
{
    UNICODE_STRING      RegistryPath;           // saved registry path
    ULONG               InstanceCount;          // FDO instance count
    USHORT              WdmVersion;             // os version
} DEVICEPCI_DATA, *PDEVICEPCI_DATA;

extern DEVICEPCI_DATA g_Data;

// PnP states
typedef enum _DEVICEPCI_PNP_STATE 
{
    PnpStateNotStarted = 0,
    PnpStateStarted,
    PnpStateStopPending,
    PnpStateStopped,
    PnpStateRemovePending,
    PnpStateRemoved,
    PnpStateSurpriseRemoved
} DEVICEPCI_PNP_STATE;


// The device extension for the device object
typedef struct _DEVICEPCI_DEVICE_EXTENSION
{
    PDEVICE_OBJECT          DeviceObject;           // pointer to the DeviceObject
    PDEVICE_OBJECT          PhysicalDeviceObject;   // underlying PDO
    PDEVICE_OBJECT          LowerDeviceObject;      // top of the device stack

    LONG                    RemoveCount;            // 1-based reference count
    KEVENT                  RemoveEvent;            // event to sync device removal

    DEVICEPCI_IO_LOCK IoLock;                 // misc io lock

    DEVICEPCI_PNP_STATE    PnpState;               // PnP state variable
    DEVICEPCI_PNP_STATE    PreviousPnpState;       // Previous PnP state variable
    LONG                    OpenHandleCount;

    PUCHAR                  Resource_portBase;              // Port resource pointer
    ULONG                   Resource_portLength;            // Port resource length
    BOOLEAN                 bResource_portMapped;           // Port resource mapped flag
    BOOLEAN                 bResource_portIsIo;             // if TRUE, use PORT functions, otherwise use REGISTER

    PKINTERRUPT             DevicePCIInterruptObject;     // Interrupt resource pointer
    ULONG                   DevicePCIInterruptVector;     // Interrupt vector
    KIRQL                   DevicePCIInterruptLevel;      // Interrupt Level
    KAFFINITY               DevicePCIInterruptAffinity;   // Interrupt affinity
    KINTERRUPT_MODE         DevicePCIInterruptMode;       // Interrupt mode (edge | level)
    BOOLEAN                 bDevicePCIInterruptShared;    // Interrupt share flag
    KDPC                    DevicePCIIsrDpc;              // DpcForIsr
} DEVICEPCI_DEVICE_EXTENSION, *PDEVICEPCI_DEVICE_EXTENSION;

#ifdef __cplusplus
extern "C" 
{
#endif

NTSTATUS __stdcall DriverEntry(
    IN  PDRIVER_OBJECT  DriverObject,
    IN  PUNICODE_STRING RegistryPath
    );

NTSTATUS __stdcall DevicePCIAddDevice(
    IN  PDRIVER_OBJECT  DriverObject,
    IN  PDEVICE_OBJECT  PhysicalDeviceObject
    );

VOID __stdcall DevicePCIUnload(
    IN  PDRIVER_OBJECT  DriverObject
    );

NTSTATUS __stdcall DevicePCIPnpDispatch(
    IN  PDEVICE_OBJECT  DeviceObject,
    IN  PIRP            Irp
    );

NTSTATUS __stdcall DevicePCIPowerDispatch(
    IN  PDEVICE_OBJECT  DeviceObject,
    IN  PIRP            Irp
    );

NTSTATUS __stdcall DevicePCIDeviceIoControlDispatch(
    IN  PDEVICE_OBJECT  DeviceObject,
    IN  PIRP            Irp
    );

NTSTATUS __stdcall DevicePCICreateDispatch(
    IN  PDEVICE_OBJECT  DeviceObject,
    IN  PIRP            Irp
    );

NTSTATUS __stdcall DevicePCICloseDispatch(
    IN  PDEVICE_OBJECT  DeviceObject,
    IN  PIRP            Irp
    );

NTSTATUS __stdcall DevicePCIReadDispatch(
    IN  PDEVICE_OBJECT  DeviceObject,
    IN  PIRP            Irp
    );

NTSTATUS __stdcall DevicePCIWriteDispatch(
    IN  PDEVICE_OBJECT  DeviceObject,
    IN  PIRP            Irp
    );

NTSTATUS __stdcall DevicePCICleanupDispatch(
    IN  PDEVICE_OBJECT  DeviceObject,
    IN  PIRP            Irp
    );

NTSTATUS __stdcall DevicePCISystemControlDispatch(
    IN  PDEVICE_OBJECT  DeviceObject,
    IN  PIRP            Irp
    );

///////////////////////////////////////////////////////////////////////////////////////////////////
// Queue Functions
///////////////////////////////////////////////////////////////////////////////////////////////////

VOID DevicePCIInitializeQueue(
    IN  PDEVICEPCI_QUEUE    QueueExtension,
    IN  PDEVICEPCI_QUEUE_STARTIO     StartIoRoutine,
    IN  PDEVICE_OBJECT      DeviceObject,
    IN  BOOLEAN             bUseDevicePCIStartIoDpc
    );

NTSTATUS DevicePCIQueueIrp(
    IN  PDEVICEPCI_QUEUE    QueueExtension,
    IN  PIRP                Irp
    );

VOID DevicePCIStartNext(
    IN  PDEVICEPCI_QUEUE    QueueExtension
    );

VOID DevicePCIFlushQueue(
    IN  PDEVICEPCI_QUEUE    QueueExtension,
    IN  PFILE_OBJECT        FileObject
    );

VOID DevicePCIInvalidateQueue(
    IN  PDEVICEPCI_QUEUE    Queue,
    IN  NTSTATUS                  ErrorStatus
    );

VOID DevicePCIPauseQueue(
    IN  PDEVICEPCI_QUEUE    QueueExtension
    );
    
VOID DevicePCIRestartQueue(
    IN  PDEVICEPCI_QUEUE    QueueExtension
    );

VOID DevicePCIStartIoDpc(
    IN  PKDPC       Dpc,
    IN  PVOID       Context,
    IN  PVOID       Unused1,
    IN  PVOID       Unused2
    );

VOID DevicePCIQueueCancelRoutine(
    IN  PDEVICE_OBJECT  DeviceObject,
    IN  PIRP            Irp
    );

///////////////////////////////////////////////////////////////////////////////////////////////////
// List functions
///////////////////////////////////////////////////////////////////////////////////////////////////

VOID DevicePCIInitializeList(
    IN  PDEVICEPCI_LIST   List,
    IN  PDEVICE_OBJECT          DeviceObject
    );

NTSTATUS DevicePCIInsertHead(
    IN  PDEVICEPCI_LIST   List, 
    IN  PIRP                Irp
    );

NTSTATUS DevicePCIInsertTail(
    IN  PDEVICEPCI_LIST   List, 
    IN  PIRP                Irp
    );

PIRP DevicePCIRemoveHead(
    IN  PDEVICEPCI_LIST   List
    );

PIRP DevicePCIRemoveTail(
    IN  PDEVICEPCI_LIST   List
    );

VOID DevicePCIFlushList(
    IN  PDEVICEPCI_LIST   List,
    IN  PFILE_OBJECT        FileObject
    );

VOID DevicePCIInvalidateList(
    IN  PDEVICEPCI_LIST   List,
    IN  NTSTATUS                ErrorStatus
    );

VOID DevicePCIListCancelRoutine(
    IN  PDEVICE_OBJECT  DeviceObject,
    IN  PIRP            Irp
    );

///////////////////////////////////////////////////////////////////////////////////////////////////
// DEVICEPCI_IO_LOCK
///////////////////////////////////////////////////////////////////////////////////////////////////

VOID DevicePCIInitializeIoLock(
    IN  PDEVICEPCI_IO_LOCK    IoLock, 
    IN  PDEVICE_OBJECT              DeviceObject
    );

NTSTATUS DevicePCICheckIoLock(
    IN  PDEVICEPCI_IO_LOCK    IoLock, 
    IN  PIRP                        Irp
    );

VOID DevicePCIPendingIoCancelRoutine(
    IN  PDEVICE_OBJECT  DeviceObject,
    IN  PIRP            Irp
    );

NTSTATUS DevicePCIIncrementIoCount(
    IN  PDEVICEPCI_IO_LOCK    IoLock
    );

VOID DevicePCIDecrementIoCount(
    IN  PDEVICEPCI_IO_LOCK    IoLock
    );

VOID DevicePCILockIo(
    IN  PDEVICEPCI_IO_LOCK    IoLock
    );

VOID DevicePCIWaitForStopIo(
    IN  PDEVICEPCI_IO_LOCK    IoLock
    );

VOID DevicePCIUnlockIo(
    IN  PDEVICEPCI_IO_LOCK    IoLock
    );

VOID DevicePCIFlushPendingIo(
    IN  PDEVICEPCI_IO_LOCK    IoLock,
    IN  PFILE_OBJECT                FileObject
    );

VOID DevicePCIInvalidateIo(
    IN  PDEVICEPCI_IO_LOCK    IoLock,
    IN  NTSTATUS                    ErrorStatus
    );

BOOLEAN DevicePCIIsr(
    IN  PKINTERRUPT Interrupt, 
    IN  PVOID       Context
    );

VOID DevicePCIDpcForIsr(
    IN  PKDPC   Dpc, 
    IN  PVOID   Context, 
    IN  PVOID   SystemArgument1, 
    IN  PVOID   SystemArgument2
    );
#ifdef __cplusplus
}
#endif

BOOLEAN DevicePCIIsStoppable(
    IN  PDEVICEPCI_DEVICE_EXTENSION    DeviceExtension
    );

BOOLEAN DevicePCIIsRemovable(
    IN  PDEVICEPCI_DEVICE_EXTENSION    DeviceExtension
    );

BOOLEAN DevicePCIAcquireRemoveLock(
    IN  PDEVICEPCI_DEVICE_EXTENSION    DeviceExtension
    );

VOID DevicePCIReleaseRemoveLock(
    IN  PDEVICEPCI_DEVICE_EXTENSION    DeviceExtension
    );

VOID DevicePCIWaitForSafeRemove(
    IN  PDEVICEPCI_DEVICE_EXTENSION    DeviceExtension
    );

NTSTATUS DevicePCISubmitIrpSync(
    IN  PDEVICE_OBJECT  DeviceObject,
    IN  PIRP            Irp
    );

VOID DevicePCIStallQueues(
    IN  PDEVICEPCI_DEVICE_EXTENSION DeviceExtension
    );

VOID DevicePCIRestartQueues(
    IN  PDEVICEPCI_DEVICE_EXTENSION DeviceExtension
    );

VOID DevicePCIFlushQueues(
    IN  PDEVICEPCI_DEVICE_EXTENSION   DeviceExtension,
    IN  PFILE_OBJECT            FileObject
    );

///////////////////////////////////////////////////////////////////////////////////////////////////
// Pnp 
///////////////////////////////////////////////////////////////////////////////////////////////////

// define this PnP IRP.  This IRP is only defined in ntddk.h normally
#if !defined(IRP_MN_QUERY_LEGACY_BUS_INFORMATION)
#define IRP_MN_QUERY_LEGACY_BUS_INFORMATION     0x18
#endif // IRP_MN_QUERY_LEGACY_BUS_INFORMATION

NTSTATUS DevicePCIStartDevice(
    IN  PDEVICEPCI_DEVICE_EXTENSION    DeviceExtension,
    IN  PIRP                            Irp
    );

NTSTATUS DevicePCIFreeResources(
    IN  PDEVICEPCI_DEVICE_EXTENSION DeviceExtension
    );

///////////////////////////////////////////////////////////////////////////////////////////////////
// Power
///////////////////////////////////////////////////////////////////////////////////////////////////



///////////////////////////////////////////////////////////////////////////////////////////////////
// Registry
///////////////////////////////////////////////////////////////////////////////////////////////////

PVOID DevicePCIRegQueryValueKey(
    IN  HANDLE  RegKeyHandle,
    IN  PWSTR   SubKeyName,
    IN  PWSTR   ValueName,
    OUT PULONG  Length
    );

VOID DevicePCIRegEnumerateKeys(
    IN  HANDLE RegKeyHandle
    );

VOID DevicePCIRegEnumerateValueKeys(
    IN  HANDLE  RegKeyHandle
    );

///////////////////////////////////////////////////////////////////////////////////////////////////
// Debug
///////////////////////////////////////////////////////////////////////////////////////////////////

// definition of debug levels

#define DBG_NONE            0
#define DBG_ERR             1
#define DBG_WARN            2
#define DBG_TRACE           3
#define DBG_INFO            4
#define DBG_VERB            5

#ifdef DEVICEPCI_WMI_TRACE

/*
tracepdb -f objchk_wxp_x86\i386\DevicePCI.pdb -p C:\DevicePCI
SET TRACE_FORMAT_SEARCH_PATH=C:\DevicePCI

tracelog -start DevicePCI -guid DevicePCI.ctl -f DevicePCI.log -flags 0x7FFFFFFF -level 5
tracelog -stop DevicePCI

tracefmt -o DevicePCI.txt -f DevicePCI.log
*/

#define WPP_AREA_LEVEL_LOGGER(Area,Lvl)           WPP_LEVEL_LOGGER(Area)
#define WPP_AREA_LEVEL_ENABLED(Area,Lvl)          (WPP_LEVEL_ENABLED(Area) && WPP_CONTROL(WPP_BIT_##Area).Level >= Lvl)

#define WPP_CONTROL_GUIDS \
    WPP_DEFINE_CONTROL_GUID(DevicePCI,(D3E371AB,D7AE,43B7,A94E,02FC147863F8), \
        WPP_DEFINE_BIT(DBG_GENERAL)                 /* bit  0 = 0x00000001 */ \
        WPP_DEFINE_BIT(DBG_PNP)                     /* bit  1 = 0x00000002 */ \
        WPP_DEFINE_BIT(DBG_POWER)                   /* bit  2 = 0x00000004 */ \
        WPP_DEFINE_BIT(DBG_COUNT)                   /* bit  3 = 0x00000008 */ \
        WPP_DEFINE_BIT(DBG_CREATECLOSE)             /* bit  4 = 0x00000010 */ \
        WPP_DEFINE_BIT(DBG_WMI)                     /* bit  5 = 0x00000020 */ \
        WPP_DEFINE_BIT(DBG_UNLOAD)                  /* bit  6 = 0x00000040 */ \
        WPP_DEFINE_BIT(DBG_IO)                      /* bit  7 = 0x00000080 */ \
        WPP_DEFINE_BIT(DBG_INIT)                    /* bit  8 = 0x00000100 */ \
        WPP_DEFINE_BIT(DBG_09)                      /* bit  9 = 0x00000200 */ \
        WPP_DEFINE_BIT(DBG_10)                      /* bit 10 = 0x00000400 */ \
        WPP_DEFINE_BIT(DBG_11)                      /* bit 11 = 0x00000800 */ \
        WPP_DEFINE_BIT(DBG_12)                      /* bit 12 = 0x00001000 */ \
        WPP_DEFINE_BIT(DBG_13)                      /* bit 13 = 0x00002000 */ \
        WPP_DEFINE_BIT(DBG_14)                      /* bit 14 = 0x00004000 */ \
        WPP_DEFINE_BIT(DBG_15)                      /* bit 15 = 0x00008000 */ \
        WPP_DEFINE_BIT(DBG_16)                      /* bit 16 = 0x00010000 */ \
        WPP_DEFINE_BIT(DBG_17)                      /* bit 17 = 0x00020000 */ \
        WPP_DEFINE_BIT(DBG_18)                      /* bit 18 = 0x00040000 */ \
        WPP_DEFINE_BIT(DBG_19)                      /* bit 19 = 0x00080000 */ \
        WPP_DEFINE_BIT(DBG_20)                      /* bit 20 = 0x00100000 */ \
        WPP_DEFINE_BIT(DBG_21)                      /* bit 21 = 0x00200000 */ \
        WPP_DEFINE_BIT(DBG_22)                      /* bit 22 = 0x00400000 */ \
        WPP_DEFINE_BIT(DBG_23)                      /* bit 23 = 0x00800000 */ \
        WPP_DEFINE_BIT(DBG_24)                      /* bit 24 = 0x01000000 */ \
        WPP_DEFINE_BIT(DBG_25)                      /* bit 25 = 0x02000000 */ \
        WPP_DEFINE_BIT(DBG_26)                      /* bit 26 = 0x04000000 */ \
        WPP_DEFINE_BIT(DBG_27)                      /* bit 27 = 0x08000000 */ \
        WPP_DEFINE_BIT(DBG_28)                      /* bit 28 = 0x10000000 */ \
        WPP_DEFINE_BIT(DBG_29)                      /* bit 29 = 0x20000000 */ \
        WPP_DEFINE_BIT(DBG_30)                      /* bit 30 = 0x40000000 */ \
        WPP_DEFINE_BIT(DBG_31)                      /* bit 31 = 0x80000000 */ \
        )

__inline VOID DevicePCIDumpIrp(
    IN PIRP Irp
    )
{
}

__inline PCHAR SystemPowerStateString(
    IN  SYSTEM_POWER_STATE  SystemState
    )
{
    return "";
}

__inline PCHAR DevicePowerStateString(
    IN  DEVICE_POWER_STATE  DeviceState
    )
{
    return "";
}

#else

// definition of debug areas

#define DBG_GENERAL         (1 << 0)
#define DBG_PNP             (1 << 1)
#define DBG_POWER           (1 << 2)
#define DBG_COUNT           (1 << 3)
#define DBG_CREATECLOSE     (1 << 4)
#define DBG_WMI             (1 << 5)
#define DBG_UNLOAD          (1 << 6)
#define DBG_IO              (1 << 7)
#define DBG_INIT            (1 << 8)

#define DBG_ALL             0xFFFFFFFF

VOID DevicePCIDebugPrint(
    IN ULONG    Area,
    IN ULONG    Level,
    IN PCCHAR   Format,
    IN          ...
    );

VOID DevicePCIDumpIrp(
    IN PIRP Irp
    );

PCHAR IrpMajorFunctionString(
    IN  UCHAR MajorFunction
    );

PCHAR PnPMinorFunctionString(
    IN  UCHAR   MinorFunction
    );

PCHAR PowerMinorFunctionString(
    IN  UCHAR   MinorFunction
    );

PCHAR SystemPowerStateString(
    IN  SYSTEM_POWER_STATE  SystemState
    );

PCHAR DevicePowerStateString(
    IN  DEVICE_POWER_STATE  DeviceState
    );

PCHAR WMIMinorFunctionString (
    IN  UCHAR MinorFunction
    );

#endif

NTSTATUS DevicePCIAccessConfigSpace(
    IN  PDEVICEPCI_DEVICE_EXTENSION DeviceExtension,
    IN  BOOLEAN                 IsRead,
    IN OUT PVOID                Buffer,
    IN  ULONG                   Offset,
    IN  ULONG                   Length,
    OUT PULONG                  ReadWrittenSize
    );

#endif  // __DEVICEPCI_H__
