// interrupt.c
//
// Generated by C DriverWizard 3.1.0 (Build 1722)
// Requires DDK Only
// File created on 5/30/2008
//

#include "pch.h"
#ifdef DEVICEPCI_WMI_TRACE
#include "interrupt.tmh"
#endif

///////////////////////////////////////////////////////////////////////////////////////////////////
//  DevicePCIIsr
//      Interrupt service routine.
//
//  Arguments:
//      IN  Interrupt
//              Interrupt resource this ISR is connected to
//
//      IN  Context
//              Our device extension
//
//  Return Value:
//      TRUE if our device interrupted and we are servicing the interrupt, 
//      FALSE otherwise
//
BOOLEAN DevicePCIIsr(
    IN  PKINTERRUPT Interrupt, 
    IN  PVOID       Context
    )
{
    PDEVICEPCI_DEVICE_EXTENSION deviceExtension;

    deviceExtension = (PDEVICEPCI_DEVICE_EXTENSION)Context;

    //*****************************************************************
    //*****************************************************************
    // TODO:  Check our device and if it caused an interrupt, stop the device 
    //        from interrupting and queue the DpcForIsr.  If our device did not 
    //        cause the interrupt, we should return FALSE.
    //*****************************************************************
    //*****************************************************************

    // If our device interrupted, queue the DpcForIsr 
    // to handle the interrupt processing
    KeInsertQueueDpc(&deviceExtension->DevicePCIIsrDpc, NULL, NULL);

    // This is our interrupt so return TRUE;
    return TRUE;
}

///////////////////////////////////////////////////////////////////////////////////////////////////
//  DevicePCIDpcForIsr
//      DPC used for interrupt processing.
//
//  Arguments:
//      IN  Dpc
//              Our DpcForIsr
//
//      IN  Context
//              Our device extension
//
//      IN  SystemArgument1
//              Unused
//
//      IN  SystemArgument2
//              Unused
//
//  Return Value:
//      none
//
VOID DevicePCIDpcForIsr(
    IN  PKDPC   Dpc, 
    IN  PVOID   Context, 
    IN  PVOID   SystemArgument1, 
    IN  PVOID   SystemArgument2
    )
{
    PDEVICEPCI_DEVICE_EXTENSION deviceExtension;
    PIRP                transferIrp;

    deviceExtension = (PDEVICEPCI_DEVICE_EXTENSION)Context;

    //*****************************************************************
    //*****************************************************************
    // TODO:  Handle any interrupt processing here including setting the device to be
    //        able to generate interrupts again
    //*****************************************************************
    //*****************************************************************

    return;
}
