// wmi.c
//
// Generated by C DriverWizard 3.1.0 (Build 1722)
// Requires DDK Only
// File created on 5/30/2008
//

#include "pch.h"
#ifdef DEVICEPCI_WMI_TRACE
#include "wmi.tmh"
#endif


///////////////////////////////////////////////////////////////////////////////////////////////////
//  DevicePCISystemControlDispatch
//      Dispatch routine for IRP_MJ_SYSTEM_CONTROL requests.
//
//  Arguments:
//      IN  DeviceObject
//              pointer to the device object for our device
//
//      IN  Irp
//              the IRP_MJ_SYSTEM_CONTROL IRP
//
//  Return Value:
//      NT status code.
//
NTSTATUS DevicePCISystemControlDispatch(
    IN  PDEVICE_OBJECT  DeviceObject,
    IN  PIRP            Irp
    )
{
    PDEVICEPCI_DEVICE_EXTENSION    deviceExtension;
    NTSTATUS                        status;
    PIO_STACK_LOCATION              stack;

    DevicePCIDebugPrint(DBG_WMI, DBG_TRACE, __FUNCTION__"++. IRP %p", Irp);

    DevicePCIDumpIrp(Irp);

    deviceExtension = (PDEVICEPCI_DEVICE_EXTENSION)DeviceObject->DeviceExtension;

    // protect againt IRP_MN_REMOVE_DEVICE
    if (!DevicePCIAcquireRemoveLock(deviceExtension))
    {
        status = STATUS_DELETE_PENDING;

        Irp->IoStatus.Status = status;
        IoCompleteRequest (Irp, IO_NO_INCREMENT);

        DevicePCIDebugPrint(DBG_WMI, DBG_WARN, __FUNCTION__"--. IRP %p, STATUS %x", Irp, status);

        return status;
    }

    // just pass it through
    IoSkipCurrentIrpStackLocation(Irp);
    status = IoCallDriver(deviceExtension->LowerDeviceObject, Irp);

    DevicePCIReleaseRemoveLock(deviceExtension);

    DevicePCIDebugPrint(DBG_WMI, DBG_TRACE, __FUNCTION__"--. IRP %p, STATUS %x", Irp, status);

    return status;
}
